#pragma once
#include "VodafoneTestCase.h"
//#define __DEBUG__ 1

// this test case will wait to send an SMS from the modem.
// if the method that sends a message returns an error it will fail.
// it will report the test as failed if any of the above happens.
// it does not wait after it has succesfully sent an SMS.
// this test basic characters and numbers can be sent via SMS.

extern const char *gTest04Description;
extern const char *gTestPhoneNumber;
extern const char *gAlphabetNumbersMessage;

class Test04 : public VodafoneTestCase {
   public: 

      Test04(VodafoneUSBModem *m) : VodafoneTestCase(m) {}
      
   private:
      virtual bool executeTest() {
         LOG(gTest04Description);    
         LinkMonitor::REGISTRATION_STATE regState = LinkMonitor::REGISTRATION_STATE_UNKNOWN;
         LinkMonitor::BEARER bearer = LinkMonitor::BEARER_UNKNOWN;
         int rssi = -1000;
         if(_modem->getLinkState(&rssi, &regState, &bearer)==0) 
            {
                if(rssi==-1000) 
                    { LOG("Checking signal strength - RSSI: Error."); return false;} 
               else 
                { LOG("Signal strength is: RSSI: %d",rssi);}
            
            
               switch(regState) {
                  case LinkMonitor::REGISTRATION_STATE_UNKNOWN:
                     LOG("regState: UNKNOWN. Failing.");
                     return false;
                  case LinkMonitor::REGISTRATION_STATE_REGISTERING:
                     LOG("regState: REGISTERING");
                     break;
                  case LinkMonitor::REGISTRATION_STATE_DENIED:
                     LOG("regState: DENIED");
                     return false;
                  case LinkMonitor::REGISTRATION_STATE_NO_SIGNAL:
                     LOG("regState: NO SIGNAL");
                     return false;
                  case LinkMonitor::REGISTRATION_STATE_HOME_NETWORK:
                     LOG("regState: HOME NETWORK");
                     break;
                  case LinkMonitor::REGISTRATION_STATE_ROAMING:
                     LOG("regState: ROAMING");
                     break;
                  default:
                     LOG("regState: ERROR. Failing.");
                     return false;
               }
            }
  
                         
         LOG("Sending SMS:' %s ' to test phone: %s , waiting for response.", gIrregularMessage, gTestPhoneNumber);
         
         int ret = _modem->sendSM(gTestPhoneNumber, gIrregularMessage);
         
         if (ret)
            {
                LOG("Error in sending the SMS message. The return values is: %d", ret);
                
                switch(ret){
                    case(NET_INVALID): LOG("Error message is: 'phone number is invalid size, must be less than 16 digits'.");break;
                    case(NET_PROTOCOL): LOG("Error message is: 'protocol error from the modem'.");break;
                    default: LOG("Undefined error message.");         

                }
                return false;
            }
         return true;                
      }
};